package routes

import (
	"net/http"

	"github.com/labstack/echo/v4"

	"git.grosinger.net/tgrosinger/tonyslist/constants/pages"
	"git.grosinger.net/tgrosinger/tonyslist/pkg/controller"
)

type login struct {
	controller.Controller
}

func (c *login) Get(ctx echo.Context) error {
	// This is guarded by a middleware which performs the auth.

	dest := ctx.QueryParam("return_to")
	if dest == "" {
		return c.Redirect(ctx, pages.Names.Home)
	}

	// Preserve any additionally query params
	values := ctx.Request().URL.Query()
	values.Del("return_to")

	query := values.Encode()
	if query != "" {
		return ctx.Redirect(http.StatusFound, dest+"?"+query)
	}
	return ctx.Redirect(http.StatusFound, dest)
}
